// By jack music,from ucancode software
// You can contact us.
// jack@ucancode.net
// Visit http://www.ucancode.net to download new version.
/********************************************************************/
/////////////////////////////////////////////////////////////////////////////
// BTAngleWnd.cpp : implementation file
//

#include "stdafx.h"
#include "BTAngleWnd.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBTAngleWnd
#pragma warning(disable: 4244)

CBTAngleWnd::CBTAngleWnd()
{
	m_dAngle = 0;
	m_bTrack = FALSE;
	m_pAttachWnd = NULL;
	m_crBack = RGB(0,0,0);
}

CBTAngleWnd::~CBTAngleWnd()
{
}

BEGIN_MESSAGE_MAP(CBTAngleWnd, CWnd)
	//{{AFX_MSG_MAP(CBTAngleWnd)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_PAINT()
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBTAngleWnd message handlers

double CBTAngleWnd::FixAngle(const double &angle)
{
	if(angle < 0.0)
		return angle+360.0;
	if(angle > 359.9)
		return angle-360.0;

	return angle;
}

double CBTAngleWnd::ComputeAngle(const CPoint &ptStart, const CPoint &ptEnd)
{
    double x, y;
	double angle;

    x = (double)(ptEnd.x - ptStart.x);
    y = (double)(ptEnd.y - ptStart.y);

    if(!x && !y)
        return 0.0;

    angle = atan2( y, x ) * (double)(180.0 / 3.14159265358979323846);

    return (angle);
}

void CBTAngleWnd::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_bTrack)
	{
		DoDrawAngleCircle(&m_DrawDC);
		int nNewAngle = FixAngle(180 - (int)ComputeAngle(point, m_ptCenter));
		m_dAngle = (double)nNewAngle;
		DoDrawAngleCircle(&m_DrawDC);
		DoUpdate();
		GetParent()->PostMessage(EX_WM_EDITCHANGE, GetDlgCtrlID(), 0);
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CBTAngleWnd::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_bTrack)
	{
		::ReleaseDC(m_hWnd, m_DrawDC.Detach());
		m_bTrack = FALSE;
		ReleaseCapture();

		DoUpdate();

		GetParent()->PostMessage(EX_WM_EDITCHANGE, GetDlgCtrlID(), 0);
	}
		
	CWnd::OnLButtonUp(nFlags, point);
}

void CBTAngleWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_DrawDC.Attach(::GetDC(m_hWnd));
	m_bTrack = TRUE;
	SetCapture();

	CWnd::OnLButtonDown(nFlags, point);

	OnMouseMove(0, point);
}

void CBTAngleWnd::DoDrawAngleCircle(CDC *pDC)
{
	int nNewAngle = FixAngle(m_dAngle);

	if (nNewAngle < 0 || nNewAngle > 359)
	{
		return;
	}

	pDC->SetROP2(R2_XORPEN);
	pDC->SelectStockObject(WHITE_PEN);

	CRect rcPos;
	GetClientRect(rcPos);
	m_ptCenter = rcPos.CenterPoint();

	double radius = rcPos.Width() / 2 - 3;

	CPoint pt;
	pt.x = m_ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt.y = m_ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	CPoint points[3];
	points[0] = pt;
	points[1].x = m_ptCenter.x -2;
	points[1].y = m_ptCenter.y;

	points[2].x = m_ptCenter.x + 2;
	points[2].y = m_ptCenter.y;

//	pDC->Polygon(points,3);

	pDC->MoveTo(m_ptCenter);
	pDC->LineTo(pt);

	CRect rc;
	rc = CRect(m_ptCenter.x - 2,m_ptCenter.y - 2,m_ptCenter.x + 2,m_ptCenter.y + 2);
	pDC->Ellipse(&rc);
}

double CBTAngleWnd::GetAngle()
{
	return m_dAngle;
}

TCHAR *CBTAngleWnd::GetAngleWindowText(TCHAR *szBuf)
{
	szBuf[0] = _T('\0');

	if (m_dAngle >= 0)
	{
		itoa((int)m_dAngle, szBuf, 10);
	}

	return(szBuf);
}

void CBTAngleWnd::SetAngleValue(const double &dAngle, BOOL bRedraw)
{
	double dAngleTemp = dAngle;
	while (dAngleTemp < 0)
	{
		dAngleTemp += 360.0;
	}

	CDC *pDC = NULL;

	if (bRedraw)
	{
		ASSERT(::IsWindow(m_hWnd));
		pDC = GetDC();
		if (pDC != NULL)
		{
			DoDrawAngleCircle(pDC);
		}
	}

	m_dAngle = dAngleTemp;

	if ((bRedraw) && (pDC != NULL))
	{
		DoDrawAngleCircle(pDC);
		ReleaseDC(pDC);
	}
}

void CBTAngleWnd::SetAngle(const double &dAngle, BOOL bRedraw)
{
	SetAngleValue(dAngle, bRedraw);
	UpdateAttachBox();
}

void CBTAngleWnd::TurnOnNow(BOOL bOn)
{
	if (bOn)
	{
		EnableWindow(TRUE);

		if (m_pAttachWnd)
		{
			m_pAttachWnd->EnableWindow(TRUE);
		}
	}
	else
	{
		EnableWindow(FALSE);
		
		if (m_pAttachWnd)
		{
			m_pAttachWnd->EnableWindow(FALSE);
		}
	}

	Invalidate(FALSE);
	UpdateWindow();
}

void CBTAngleWnd::UpdateAttachBox()
{
	if (m_pAttachWnd)
	{
		TCHAR szBuf[20];
		GetAngleWindowText(szBuf);
		m_pAttachWnd->SetWindowText(szBuf);
	}
}

void CBTAngleWnd::AttachToEditBox(CWnd *pWnd)
{
	m_pAttachWnd = pWnd;
}

void CBTAngleWnd::UpdateAngleBox(BOOL bRedraw)
{
	CDC *pDC = NULL;

	if (bRedraw)
	{
		ASSERT(::IsWindow(m_hWnd));
		pDC = GetDC();
		if (pDC != NULL)
		{
			DoDrawAngleCircle(pDC);
		}
	}

	if ((bRedraw) && (pDC != NULL))
	{
		DoDrawAngleCircle(pDC);
		ReleaseDC(pDC);
	}
}

void CBTAngleWnd::DoUpdate(BOOL bRedraw)
{
	UpdateAngleBox(bRedraw);
	UpdateAttachBox();
}

void CBTAngleWnd::OnPaint()
{
	PAINTSTRUCT ps;
	CDC *pDC = BeginPaint(&ps);

	if (pDC == NULL)
	{
		return;
	}

	CBrush brFrame(GetSysColor(COLOR_3DFACE));
	CBrush brBack(m_crBack);

	CBrush *pOldBrush = IsWindowEnabled() ? &brBack : &brFrame;

	CRect r;
	GetClientRect(r);
	pDC->FillRect(&r, &brFrame);

	m_ptCenter = r.CenterPoint();
	
	pDC->SelectStockObject(NULL_PEN);
	pDC->SelectObject(pOldBrush);
	pDC->Ellipse(r);

	CPen hi(PS_SOLID, 2, GetSysColor(COLOR_3DSHADOW));
	CPen lo(PS_SOLID, 2, GetSysColor(COLOR_3DHILIGHT));

	pDC->SelectObject(hi);
	pDC->Arc(r, CPoint(r.right, r.top), CPoint(r.left, r.bottom));
	pDC->SelectObject(lo);
	pDC->Arc(r, CPoint(r.left, r.bottom), CPoint(r.right, r.top));

	pDC->SetPixel(m_ptCenter, RGB(0xff, 0xff, 0xff));

	if (IsWindowEnabled())
	{
		DoDrawAngleCircle(pDC);
	}

	CPoint ptCenter = r.CenterPoint();

	double radius = r.Width() / 2-3;

	CPen newPen(PS_SOLID,2,RGB(255,0,0));

	CPen *pOldPen = (CPen*)pDC->SelectObject(&newPen);

	// 0
	int nNewAngle = 0;

	CPoint pt0;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	CPoint pt1;
	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);

	// 45
	nNewAngle = 45;
	radius = r.Width() / 2-3;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	
	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);

	// 90
	nNewAngle = 90;
	radius = r.Width() / 2-3;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	
	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);

	// 135
	nNewAngle = 135;
	radius = r.Width() / 2-3;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	
	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);

	// 180
	nNewAngle = 180;
	radius = r.Width() / 2-3;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	
	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);

	// 225
	nNewAngle = 225;
	radius = r.Width() / 2-3;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	
	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);


	// 270
	nNewAngle = 270;
	radius = r.Width() / 2-3;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	
	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);


	// 315
	nNewAngle = 315;
	radius = r.Width() / 2-3;
	pt0.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt0.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;

	radius = r.Width()/2 - r.Width() / 10;
	pt1.x = ptCenter.x + sin((double)(nNewAngle + 90) * (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	pt1.y = ptCenter.y + cos((double)(nNewAngle + 90)* (double)(3.14159265358979323846 / 180.0)) * radius + 0.5;
	
	pDC->MoveTo(pt0);
	pDC->LineTo(pt1);

	pDC->SelectObject(pOldPen);

	EndPaint(&ps);
}
